jQuery( function () {
	'use strict';
    // Save Settings & API Call for Activate License
    jQuery('#ppbf_activate_changes').on('click', function (e) {
        e.preventDefault();
        var ppbf_purchase_source = jQuery("#ppbf-purchase-source").val();
        var ppbf_purchase_key = jQuery("#ppbf-purchase-key").val();
        var ppbf_admin_email = jQuery("#ppbf-admin-email").val();
        if (ppbf_purchase_source === '' || ppbf_purchase_key === '' || ppbf_admin_email === '') {
            jQuery("#error-msg").fadeIn().html("* All fields are mandatory.").delay(5000).fadeOut("slow");
        } else {
            jQuery.ajax({
                type: "post",
                url: ppbf_obj.ajaxurl,
                data: {
                    action: 'ppbf_activation_api_call',
                    ppbf_purchase_source: ppbf_purchase_source,
                    ppbf_purchase_key: ppbf_purchase_key,
                    ppbf_admin_email: ppbf_admin_email
                },
                success: function (response) {
                    var result = JSON.parse(response);
                    if (result.success) {
                        swal(
                            'Success',
                            result.message,
                            'success'
                        );
                        window.location.href = "admin.php?page=ppbf-settings";
                    } else if(result.success == false) {
                        swal(
                            'Error!',
                            result.message,
                            'error'
                        );
                    } else {
                        swal(
                            'Error!',
                            ppbf_obj.errormgs,
                            'error'
                        );
                    }
                }
            });
        }
    });

    // Save Settings & API Call for Deactivate License
    jQuery('#ppbf_deactivate_changes').on('click', function (e) {
        e.preventDefault();
        var ppbf_purchase_source = jQuery("#ppbf-purchase-source").val();
        var ppbf_purchase_key = jQuery("#ppbf-purchase-key").val();
        var ppbf_admin_email = jQuery("#ppbf-admin-email").val();
        if (ppbf_purchase_source === '' || ppbf_purchase_key === '' || ppbf_admin_email === '') {
            jQuery("#error-msg").fadeIn().html("* All fields are mandatory.").delay(5000).fadeOut("slow");
        } else {
            jQuery.ajax({
                type: "post",
                url: ppbf_obj.ajaxurl,
                data: {
                    action: 'ppbf_deactivation_api_call',
                    ppbf_purchase_source: ppbf_purchase_source,
                    ppbf_purchase_key: ppbf_purchase_key,
                    ppbf_admin_email: ppbf_admin_email
                },
                success: function (response) {
                    var result = JSON.parse(response);
                    if (result.success) {
                        swal(
                            'Success',
                            result.message,
                            'success'
                        );
                        window.location.href = "admin.php?page=ppbf-settings";
                    } else if(result.success == false) {
                        swal(
                            'Error!',
                            result.message,
                            'error'
                        );
                    } else {
                        swal(
                            'Error!',
                            ppbf_obj.errormgs,
                            'error'
                        );
                    }
                }
            });
        }
    });
} );
