<?php

class Prowc_PPBF_Parenthesis extends Prowc_PPBF_TerminalExpression {

    protected $precedence = 6;

    public function operate(Prowc_PPBF_Stack $stack) {
    }

    public function getPrecedence() {
        return $this->precedence;
    }

    public function isNoOp() {
        return true;
    }

    public function isParenthesis() {
        return true;
    }

    public function isOpen() {
        return $this->value == '(';
    }

}

class Prowc_PPBF_Number extends Prowc_PPBF_TerminalExpression {

    public function operate(Prowc_PPBF_Stack $stack) {
        return $this->value;
    }

}

abstract class Prowc_PPBF_Operator extends Prowc_PPBF_TerminalExpression {

    protected $precedence = 0;
    protected $leftAssoc = true;

    public function getPrecedence() {
        return $this->precedence;
    }

    public function isLeftAssoc() {
        return $this->leftAssoc;
    }

    public function isOperator() {
        return true;
    }

}

class Prowc_PPBF_Addition extends Prowc_PPBF_Operator {

    protected $precedence = 4;

    public function operate(Prowc_PPBF_Stack $stack) {
        return $stack->pop()->operate($stack) + $stack->pop()->operate($stack);
    }

}

class Prowc_PPBF_Subtraction extends Prowc_PPBF_Operator {

    protected $precedence = 4;

    public function operate(Prowc_PPBF_Stack $stack) {
        $left = $stack->pop()->operate($stack);
        $right = $stack->pop()->operate($stack);
        return $right - $left;
    }

}

class Prowc_PPBF_Multiplication extends Prowc_PPBF_Operator {

    protected $precedence = 5;

    public function operate(Prowc_PPBF_Stack $stack) {
        return $stack->pop()->operate($stack) * $stack->pop()->operate($stack);
    }

}

class Prowc_PPBF_Division extends Prowc_PPBF_Operator {

    protected $precedence = 5;

    public function operate(Prowc_PPBF_Stack $stack) {
        $left = $stack->pop()->operate($stack);
        $right = $stack->pop()->operate($stack);
        return $right / $left;
    }

}

class Prowc_PPBF_Power extends Prowc_PPBF_Operator {

    protected $precedence = 5;

    public function operate(Prowc_PPBF_Stack $stack) {
        $left = $stack->pop()->operate($stack);
        $right = $stack->pop()->operate($stack);
        return pow($left,$right);
    }
}
