<?php

abstract class Prowc_PPBF_TerminalExpression {

    protected $value = '';

    public function __construct($value) {
        $this->value = $value;
    }

    public static function factory($value) {

        if (is_object($value) && $value instanceof Prowc_PPBF_TerminalExpression) {
            return $value;
        } elseif (is_numeric($value)) {
            return new Prowc_PPBF_Number($value);
        } elseif ($value == '+') {
            return new Prowc_PPBF_Addition($value);
        } elseif ($value == '-') {
            return new Prowc_PPBF_Subtraction($value);
        } elseif ($value == '*') {
            return new Prowc_PPBF_Multiplication($value);
        } elseif ($value == '/') {
            return new Prowc_PPBF_Division($value);
        } elseif (in_array($value, array('(', ')'))) {
            return new Prowc_PPBF_Parenthesis($value);
        } elseif ($value == '^') {
            return new Prowc_PPBF_Power($value);
        }
        throw new Exception('Undefined Value ' . $value);
    }

    abstract public function operate(Prowc_PPBF_Stack $stack);

    public function isOperator() {
        return false;
    }

    public function isParenthesis() {
        return false;
    }

    public function isNoOp() {
        return false;
    }

    public function render() {
        return $this->value;
    }
}
