<?php

if (!defined('ABSPATH')) {
    exit;
}

/* ProWCPlugins licensing START */
define('PPBF_NAME', 'Product Price by Formula Pro for WooCommerce');

add_action('admin_menu', 'ppbf_settings_page');
add_action('admin_enqueue_scripts', 'ppbf_scripts');

//WDT Settings page options
function ppbf_settings_page() {
    add_menu_page(__('PPBF Settings', PPBF_TEXTDOMAIN), __('PPBF Settings', PPBF_TEXTDOMAIN), 'manage_options', 'ppbf-settings', 'ppbf_callback', 'dashicons-admin-settings');
}

// Enque CSS/JS 
function ppbf_scripts() {
    wp_register_script('ppbf-script', PPBF_URL . 'assets/js/ppbf-script.js', array('jquery'), false, true);
    wp_enqueue_script('ppbf-script');
    wp_localize_script('ppbf-script', 'ppbf_obj', 
        array('ajaxurl' => admin_url('admin-ajax.php'), 'errormgs' => __("Something went wrong. Please try again later", PPBF_TEXTDOMAIN)
        )
    );
    wp_enqueue_style('ppbf-swt-style', PPBF_URL . 'assets/css/sweetalert2.min.css');
    wp_enqueue_script('ppbf-swt-script', PPBF_URL . 'assets/js/sweetalert2.all.min.js', array('jquery'));
}

/**
 * ProWC Settings
 */
function ppbf_callback() {
    $ppbf_purchase_source = get_option('ppbf_purchase_source');
    $ppbf_purchase_key = get_option('ppbf_purchase_key');
    $ppbf_activation_type = get_option('ppbf_activation_type');
    $ppbf_admin_email = get_option( 'admin_email' );
    $ppbf_status = get_option('ppbf_activationinit_stauts');
    $ppbf_res_status = get_option('ppbf_activationinitres_stauts');
    
?>
    <div class="wrap">
        <h1><?php _e('Product Price by Formula Pro for WooCommerce:', PPBF_TEXTDOMAIN); ?></h1>
        <h4><?php _e('Please select Prowc Plugins from below dropdown if you have purchased it.', PPBF_TEXTDOMAIN); ?></h4>
        <span class='error-message'><?php if($ppbf_res_status == 'refunded' || $ppbf_res_status == 'inactive' ){ esc_html_e('Your license status is ' . $ppbf_res_status, PPBF_TEXTDOMAIN);}?></span>
        <form method="post" id="ppbf-form-id">
            <table class="form-table" role="presentation">
                <tbody>
                    <tr>
                        <th scope="row">
                            <label for="ppbf-purchase-source"><?php _e('Purchase Source', PPBF_TEXTDOMAIN); ?></label>
                            <span style="color: #ff0000;">*</span>
                        </th>
                        <td>
                            <select name="ppbf_purchase_source" id="ppbf-purchase-source" class="regular-text">
                                <option value=""><?php _e('Select Source', PPBF_TEXTDOMAIN); ?></option>
                                <option value="envato" <?php if ($ppbf_purchase_source == "envato") { echo "selected"; } ?>><?php _e('Envato', PPBF_TEXTDOMAIN); ?></option>
                                <option value="prowcplugins" <?php if ($ppbf_purchase_source == "prowcplugins") { echo "selected"; } ?>><?php _e('ProWC Plugins', PPBF_TEXTDOMAIN); ?></option>
                            </select>
                        </td>
                    </tr>
                    <tr>
                        <th scope="row">
                            <label for="ppbf-purchase-key"><?php _e('Purchase Key', PPBF_TEXTDOMAIN); ?></label>
                            <span style="color: #ff0000;">*</span>
                        </th>
                        <td>
                            <input type="text" name="ppbf_purchase_key" id="ppbf-purchase-key" value="<?php echo $ppbf_purchase_key; ?>" class="regular-text">
                        </td>
                    </tr>
                    <tr>
                        <th scope="row">
                            <label for="ppbf-admin-email"><?php _e('Email Address', PPBF_TEXTDOMAIN); ?></label>
                            <span style="color: #ff0000;">*</span>
                        </th>
                        <td>
                            <input type="text" name="ppbf_admin_email" id="ppbf-admin-email" value="<?php echo $ppbf_admin_email; ?>" class="regular-text">
                            <p class="description"><?php _e('We will use this email for future conversation.', PPBF_TEXTDOMAIN); ?></p>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <?php
                                if($ppbf_res_status == 'refunded' || $ppbf_res_status == 'inactive' ){ return; }
                                    if ($ppbf_activation_type == 'activate') { ?>
                                <input type="button" name="ppbf_deactivate_changes" id="ppbf_deactivate_changes" class="button button-primary" value="Deactivate">
                            <?php } else { ?>
                                <input type="button" name="ppbf_activate_changes" id="ppbf_activate_changes" class="button button-primary" value="Activate">
                                <?php
                                    }
                            ?>
                            <p style="color: #ff0000;" id="error-msg"></p>
                        </td>
                    </tr>
                </tbody>
            </table>
        </form>
    </div>
    <?php
}

/**
 * 
 * Plugin key activation Message
 * 
 **/
function ppbf_author_admin_notice(){
    $ppbf_purchase_source = get_option('ppbf_purchase_source');
    $ppbf_purchase_key = get_option('ppbf_purchase_key');
    $ppbf_activation_type = get_option('ppbf_activation_type');
    $ppbf_admin_email = get_option( 'admin_email' );
    $ppbf_status = get_option('ppbf_activationinit_stauts');
    $ppbf_res_status = get_option('ppbf_activationinitres_stauts');

    $ppbf_admin_notice_messagebox_url = '';
    if( $ppbf_purchase_source == 'envato' ){
        $ppbf_admin_notice_messagebox_url = 'https://codecanyon.net/item/product-price-by-formula-pro-for-woocommerce/reviews/25633662?utf8=%E2%9C%93&reviews_controls%5Bsort%5D=ratings_descending'; 
    }else{
        $ppbf_admin_notice_messagebox_url = 'https://prowcplugins.com/downloads/product-price-by-formula-pro-for-woocommerce/#review-section'; 
    }

    global $pagenow;

	if ( $pagenow == 'admin.php' ) {

        if ( !empty($ppbf_purchase_source) && !empty($ppbf_purchase_key) && !empty($ppbf_activation_type) && !empty($ppbf_admin_email)  ) {
            if($ppbf_res_status === 'activated'){

                echo '<div class="notice notice-info is-dismissible">
                <p>Hi, you are now using <strong>Product Price by Formula Pro for WooCommerce</strong> plugin. I would really appreciate it if you could give me the five star to our plugin. </p>
                <p><a href= '. $ppbf_admin_notice_messagebox_url .'  target="_blank" class="rating-link"><strong> Okay, you deserve it </strong></a></p>
                    </div>';
            
            }
        }
    }
}
add_action('admin_notices', 'ppbf_author_admin_notice');

// Ajax action Call for Activate License
add_action('wp_ajax_ppbf_activation_api_call', 'ppbf_activation_api_call');
function ppbf_activation_api_call() {
    $ppbf_purchase_source = sanitize_text_field($_POST['ppbf_purchase_source']);
    $ppbf_purchase_key = sanitize_text_field($_POST['ppbf_purchase_key']);
    $ppbf_activation_type = 'activate';
    $ppbf_admin_email = sanitize_email($_POST['ppbf_admin_email']);
    $apiUrl = PPBF_STORE_URL."/wp-json/api/v1/verifypurchase?purchase_source=".$ppbf_purchase_source."&purchase_name=".PPBF_NAME."&purchase_email=".$ppbf_admin_email."&purchase_key=".$ppbf_purchase_key."&purchase_site=".PPBF_SITE."&activation_type=".$ppbf_activation_type;
    
    if (!empty($ppbf_purchase_source)) {
        $response = wp_remote_retrieve_body( wp_remote_post($apiUrl));
        $res = json_decode($response);
        
        if ($res->success == 1) {
            update_option('ppbf_purchase_source', $ppbf_purchase_source);
            update_option('ppbf_purchase_key', $ppbf_purchase_key);
            update_option('ppbf_activation_type', $ppbf_activation_type);
            update_option('ppbf_activationinitres_stauts',$res->status);
            update_option('admin_email', $ppbf_admin_email);
            
            echo $response;
            exit;
        } else if (!$res->success){
            echo $response;
            exit; 
        } else {
            $message = array(
                'success' => false,
                'status' => 'failed',
                'message' => __('Something went wrong',PPBF_TEXTDOMAIN)
            );
            $response = json_encode($message);
            echo $response;
            exit;
        }
    }
}

// Ajax action Call for Activate License
add_action('wp_ajax_ppbf_deactivation_api_call', 'ppbf_deactivation_api_call');
function ppbf_deactivation_api_call() {
    $ppbf_purchase_source = sanitize_text_field($_POST['ppbf_purchase_source']);
    $ppbf_purchase_key = sanitize_text_field($_POST['ppbf_purchase_key']);
    $ppbf_activation_type = 'deactivate';
    $ppbf_admin_email = sanitize_email($_POST['ppbf_admin_email']);
    $apiUrl = PPBF_STORE_URL."/wp-json/api/v1/verifypurchase?purchase_source=".$ppbf_purchase_source."&purchase_name=".PPBF_NAME."&purchase_email=".$ppbf_admin_email."&purchase_key=".$ppbf_purchase_key."&purchase_site=".PPBF_SITE."&activation_type=".$ppbf_activation_type;

    if (!empty($ppbf_purchase_source)) {
        $response = wp_remote_retrieve_body( wp_remote_post($apiUrl) );
        $res = json_decode($response);
        
        if ($res->success == 0) {
            update_option('ppbf_purchase_source', $ppbf_purchase_source);
            update_option('ppbf_purchase_key', $ppbf_purchase_key);
            update_option('ppbf_activation_type', $ppbf_activation_type);
            update_option('ppbf_activationinitres_stauts',$res->status);
            update_option('admin_email', $ppbf_admin_email);
            
            echo $response;
            exit;
        } else if (!$res->success){
            echo $response;
            exit; 
        } else {
            $message = array(
                'success' => false,
                'status' => 'failed',
                'message' => __('Something went wrong',PPBF_TEXTDOMAIN)
            );
            $response = json_encode($message);
            echo $response;
            exit;
        }
    }
}

/*
 * Cron Schedule change filter
 */
function ppbf_verifylicense_everyday( $schedules ) {
    $schedules['daily'] = array(
            'interval'  => 86400, // day
            'display'   => __('Once Daily', PPBF_TEXTDOMAIN)
    );

    return $schedules;
}
add_filter('cron_schedules', 'ppbf_verifylicense_everyday');

/*
 * Schedule an action if it's not already scheduled
 */
if(!wp_next_scheduled ('ppbf_verifylicense_everyday')){
    wp_schedule_event(time(), 'daily', 'ppbf_verifylicense_everyday');
}
/*
 * Hook into that action that'll fire every day
 */
add_action('ppbf_verifylicense_everyday', 'ppbf_check_license_verification');

function ppbf_check_license_verification(){
    $ppbf_purchase_source = get_option('ppbf_purchase_source');
    $ppbf_purchase_key = get_option('ppbf_purchase_key');
    $ppbf_activation_type = 'initiatelicense';
    $ppbf_admin_email = get_option( 'admin_email' );
    $apiUrl = PPBF_STORE_URL."/wp-json/api/v1/verifypurchase?purchase_source=".$ppbf_purchase_source."&purchase_name=".PPBF_NAME."&purchase_email=".$ppbf_admin_email."&purchase_key=".$ppbf_purchase_key."&purchase_site=".PPBF_SITE."&activation_type=".$ppbf_activation_type;

    if (!empty($ppbf_purchase_source)) {
        $response = wp_remote_retrieve_body( wp_remote_post($apiUrl) );
        $res = json_decode($response);
        
        if ($res->success == 1) {
            update_option('ppbf_activationinitres_stauts',$res->status);
            update_option('ppbf_activationinit_stauts',$res->message);
        }
    }
}
